ChatUIComponent

9 Jul 202624 minutes to read

Represents the Essential JS 2 VueJS ChatUI Component

<ejs-chatui ></ejs-chatui>

Properties

attachmentSettings FileAttachmentSettingsModel

Specifies the configuration options for attachment handling.
Includes save URL, allowed file types, and maximum file size.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <br>
    <ejs-chatui :user="currentUser" :enableAttachments="true" :attachmentSettings="attachmentSettings"></ejs-chatui>
  </div>
</template>
<script>
import { ChatUIComponent } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent
  },
  data () {
    return {
      attachmentSettings: {
        saveUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Save',
        removeUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
        allowedFileTypes: '.pdf'
      },
      currentUser: {
        id: "user1",
        user: "Albert",
      }
    }
  }
}
</script>

Defaults to null

autoScrollToBottom boolean

Specifies whether the UI should automatically scroll to the bottom when a new message is added to the Chat UI component.
When set to true, the chat will automatically scroll to display the latest message, ensuring that users can see new messages without manual intervention.

Defaults to false

cssClass string

Specifies custom CSS classes for the Chat UI component.
This property enables the application of additional styling options to customize the visual appearance of the chat interface.

Defaults to ’’

emptyChatTemplate string|function

Specifies the template for rendering the empty state of the Chat UI component.
This property can accept either a string or a function to customize the appearance when there are no messages to display in the chat.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui emptyChatTemplate="emptyChatTemplate" :user="currentUser">
      <template v-slot:emptyChatTemplate="">
        <div class="empty-chat-text">
            <h4><span class="e-icons e-comment-show"></span></h4>
            <h4>No Messages Yet</h4>
            <p>Start a conversation to see your messages here.</p>
          </div>
      </template>
    </ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert",
      }
    };
  },
};
</script>

Defaults to ’’

enableAttachments boolean

Specifies whether the attachments is enabled in the Chat UI component.

Defaults to false

enableCompactMode boolean

Enables the compact mode layout in the Chat UI component.
When enabled, all messages are aligned to the left side regardless of the sender, creating a simplified chat view.
This mode is useful for dense group conversations or compact displays (e.g., mobile,embedded).
Example: compactMode: true

Defaults to false

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRtl boolean

Enable or disable rendering component in right to left direction.

Defaults to false

footerTemplate string|function

Specifies the template for the footer area in the Chat UI component.
Defines the content or layout used to render the footer, which can be provided as a string or a function.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui ref="chatInstance" id="footerTemplate" footerTemplate="footerTemplate" :user="currentUser">
      <template v-slot:footerTemplate="">
        <div class="custom-footer">
          <input id="chatTextArea" class="e-input" placeholder="Type your message..."></input>
          <button id="sendMessage" class="e-btn e-primary"@click="buttonClick">
            <span class="e-icons e-send-1"></span>
          </button>
        </div>
      </template>
      <e-messages>
        <e-message :author="currentUser" text="Hi Michale, are we on track for the deadline?" ></e-message>
        <e-message :author="michaleUser" text="Yes, the design phase is complete." ></e-message>
        <e-message :author="currentUser" text="I’ll review it and send feedback by today." ></e-message>
      </e-messages>
    </ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent, MessagesDirective, MessageDirective } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent,
    'e-messages': MessagesDirective,
    'e-message': MessageDirective
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert",
      },
      michaleUser: {
        id: "user2",
        user: "Michale Suyama",
      }
    };
  },
  methods: {
    buttonClick: function () {
      let defaultChat = this.$refs.chatInstance.ej2Instances;
      const textArea = document.getElementById('chatTextArea');
      if (textArea && textArea?.value.length > 0) {
        let value = textArea.value;
        textArea.value = '';
        defaultChat.addMessage(
        {
          author: this.michaleUser,
          text: value
        });
      }
    }
  }
};
</script>

Defaults to ’’

headerIconCss string

Specifies the CSS class for the header icon in the Chat UI component.
This property allows for custom styling of the header icon.

Defaults to ’’

headerText string

Specifies the header text to be displayed in the Chat UI component.
This property defines the text that appears in the header, which can indicate the current participant’s username or the group name, providing context for the conversation.

Defaults to ‘Chat’

headerToolbar ToolbarSettingsModel

Specifies the header toolbar settings for the Chat UI component.
Represents the configuration for toolbar items and actions within the component.

Defaults to null

height string|number

Specifies the height of the Chat UI component.

Defaults to ‘100%’

loadOnDemand boolean

Enables on-demand loading of messages, typically triggered as the user scrolls through the chat history.
When set to true, older messages will load progressively, improving performance for large message histories by avoiding initial loading of all messages.

Defaults to false

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to ’’

mentionTriggerChar string

Specifies the character that triggers the @mention suggestion popup in the chat input.
The trigger character must be a single character, such as ‘@’ or ‘#’, and is case-sensitive in the input.

Defaults to ’@’

mentionUsers UserModel[]

Specifies the list of users available for mention in the chat UI.
This property defines an array of user objects that populate the @mention suggestion popup when the mention trigger character is typed.
When typing the mentionTriggerChar (e.g., ‘@’) followed by characters filters this list to show matching users.

Defaults to null

messageTemplate string|function

Specifies the template for rendering individual messages in the Chat UI component.
This property can accept either a string or a function to customize the appearance of messages. The template context includes message and index.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui id="messageTemplate" messageTemplate="messageTemplate" :user="currentUser">
      <template v-slot:messageTemplate="{data}">
        <div class="message-items e-card">
          <div class="message-text"></div>
        </div>
      </template>
      <e-messages>
        <e-message :author="currentUser" text="Hi Michale, are we on track for the deadline?" ></e-message>
        <e-message :author="michaleUser" text="Yes, the design phase is complete." ></e-message>
        <e-message :author="currentUser" text="I’ll review it and send feedback by today." ></e-message>
      </e-messages>
    </ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent, MessagesDirective, MessageDirective } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent,
    'e-messages': MessagesDirective,
    'e-message': MessageDirective
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert",
      },
      michaleUser: {
        id: "user2",
        user: "Michale Suyama",
      }
    };
  },
};
</script>

Defaults to ’’

messageToolbarSettings MessageToolbarSettingsModel

Specifies the settings for the message toolbar in the Chat UI component.
Configures the toolbar options associated with each message such as Reply, Forward, Copy, Pin, and Delete.
If ‘items’ is not provided, default toolbar actions [‘Copy’, ‘Reply’, ‘Pin’, ‘Delete’] will be rendered.

<template>
  <div id="container" style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui :user="currentUser" ref="chatui" :messageToolbarSettings="toolbarSettings">
      <e-messages>
        <e-message :author="currentUser" text="Hi Michale, are we on track for the deadline?" />
        <e-message :author="michaleUser" text="Yes, the design phase is complete." />
        <e-message :author="currentUser" text="I’ll review it and send feedback by today." />
      </e-messages>
    </ejs-chatui>
  </div>
</template>

<script>
import {
  ChatUIComponent,
  MessagesDirective,
  MessageDirective
} from '@syncfusion/ej2-vue-interactive-chat';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

export default {
  components: {
    'ejs-chatui': ChatUIComponent,
    'e-messages': MessagesDirective,
    'e-message': MessageDirective
  },
  data() {
    return {
      currentUser: { id: 'user1', user: 'Albert' },
      michaleUser: { id: 'user2', user: 'Michale Suyama' },
      toolbarSettings: {
        items: [
          { type: 'Button', iconCss: 'e-icons e-chat-forward', tooltip: 'Forward' },
          { type: 'Button', iconCss: 'e-icons e-chat-copy', tooltip: 'Copy' },
          { type: 'Button', iconCss: 'e-icons e-chat-reply', tooltip: 'Reply' },
          { type: 'Button', iconCss: 'e-icons e-chat-pin', tooltip: 'Pin' },
          { type: 'Button', iconCss: 'e-icons e-chat-trash', tooltip: 'Delete' }
        ],
        itemClicked: (args) => {
          if (args.item.prefixIcon === 'e-icons e-chat-forward') {
            const chatui = this.$refs.chatui.ej2Instances;
            const newMessageObj = {
              id: 'chat-message-' + (chatui.messages.length + 1).toString(),
              isForwarded: true,
              isPinned: args.message.isPinned,
              author: args.message.author,
              text: args.message.text,
              timeStamp: args.message.timeStamp,
              timeStampFormat: args.message.timeStampFormat,
              status: args.message.status,
              replyTo: args.message.replyTo
            };
            chatui.addMessage(newMessageObj);
          }
        }
      }
    };
  }
};
</script>

Defaults to []

messages MessageModel[]

Specifies a collection of messages within the Chat UI component.
Each message is represented by a MessageModel object, containing properties such as text, author, timestamp, and status.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui :user="currentUser" :loadOnDemand="true" :messages="chatMessages" :created="created"></ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert",
      },
      michaleUser: {
        id: "user2",
        user: "Michale Suyama",
      },
      chatMessages: []
    };
  },
  methods: {
    created() {
      this.chatMessages = Array.from({ length: 150 }, (_, i) => ({
        text: i % 2 === 0
          ? `Message ${i + 1} from Michale`
          : `Message ${i + 1} from Albert`,
        author: (i % 2 === 0) ? this.michaleUser : this.currentUser
      }));
    }
  }
};
</script>

Defaults to null

placeholder string

Specifies the placeholder text for the message input textarea in the Chat UI component.

Defaults to ‘Type your message…’

showFooter boolean

Specifies whether to show or hide footer in the Chat UI component.
When set to true, the footer will be visible in the Chat UI component. If false, the footer will be hidden.

Defaults to true

showHeader boolean

Specifies whether the header is displayed in the Chat UI component.
This property controls the visibility of the header, allowing users to show or hide it as needed.
When set to false, the header will be hidden from view.

Defaults to true

showTimeBreak boolean

Specifies whether time breaks are enabled for grouping chat messages by date.
When set to true, messages will be grouped based on their timestamp, creating date-wise separators within the chat.

Defaults to false

showTimeStamp boolean

Specifies whether timestamps are displayed alongside each message in the Chat UI component.
When set to true, timestamps will appear with each message, helping users track the timing of conversations.

Defaults to true

suggestionTemplate string|function

Specifies the template for rendering suggestion items in the Chat UI component.
Defines the content or layout used to render suggestion items, and can be either a string or a function.
The template context includes the index and suggestion text.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui id="suggestionTemplate" :suggestions="suggestions" suggestionTemplate="suggestionTemplate" :user="currentUser">
      <template v-slot:suggestionTemplate="{data}">
        <div class='suggestion-item active'>
          <div class="content"></div>
        </div>
      </template>
      <e-messages>
        <e-message :author="currentUser" text="Hi Michale, are we on track for the deadline?" ></e-message>
        <e-message :author="michaleUser" text="Yes, the design phase is complete." ></e-message>
      </e-messages>
    </ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent, MessagesDirective, MessageDirective } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent,
    'e-messages': MessagesDirective,
    'e-message': MessageDirective
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert"
      },
      michaleUser: {
        id: "user2",
        user: "Michale Suyama"
      },
      suggestions: ["Okay will check it", "Sounds good!"]
    };
  },
};
</script>

Defaults to ’’

suggestions string[]

Specifies the list of message suggestions displayed above the input textarea in the Chat UI component.
This property represents an array of suggestions that can assist the user in composing messages, providing quick replies.

<template>
  <div style="height: 380px; width: 450px;">
    <ejs-chatui
      id="chatUI"
      :user="currentUserModel"
      headerText="Chat UI with Markdown"
      :suggestions="suggestionTexts"
      :messages="chatMessages"
      @messageSend="onMessageSend"
    ></ejs-chatui>
  </div>
</template>

<script>
import { marked } from 'marked';
import { ChatUIComponent } from '@syncfusion/ej2-vue-interactive-chat';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
declare var DOMPurify: any;

export default {
  name: 'App',
  components: {
    'ejs-chatui': ChatUIComponent
  },
  data() {
    const currentUserModel = {
      id: 'user1',
      user: 'Albert'
    };
    
    const michaleUserModel = {
      id: 'user2',
      user: 'Michale Suyama'
    };
    
    const suggestions = [
      {
        displayText: 'Share quick link',
        markdownText: 'Check out our [project dashboard](https://dashboard.example.com) for updates!',
      },
      {
        displayText: 'Emphasize priority',
        markdownText: 'This is **high priority** and needs _immediate attention_.',
      }
    ];
    
    return {
      currentUserModel,
      michaleUserModel,
      suggestions,
      suggestionTexts: suggestions.map(s => s.displayText),
      chatMessages: [
        {
          author: currentUserModel,
          text: marked.parse('Hey Michale, did you review the _new API documentation_?'),
          timeStamp: new Date('2024-01-15T09:30:00')
        },
        {
          author: michaleUserModel,
          text: marked.parse('Yes! The **endpoint specifications** look great. Check the [integration guide](https://api.example.com/docs) when you get a chance.'),
          timeStamp: new Date('2024-01-15T09:32:00')
        }
      ]
    };
  },
  methods: {
    onMessageSend(args) {
      args.cancel = true;
      const suggestion = this.suggestions.find(s => s.displayText === args.message.text);
      const messageText = suggestion ? suggestion.markdownText : args.message.text;
      const parsedText = DOMPurify.sanitize(marked.parse(messageText));
      const newMessage = {
        text: parsedText,
        author: this.currentUserModel,
        timeStamp: new Date()
      };
      this.chatMessages = [...this.chatMessages, newMessage];
    }
  }
};
</script>

Defaults to null

timeBreakTemplate string|function

Defines a custom template for rendering time breaks in the Chat UI component.
Accepts a string or function that formats the appearance of date-based separators, allowing customization of how messages are visually grouped by date.

Defaults to ’’

timeStampFormat string

Specifies the format of the value that to be displayed in component.
By default, the format will be set based on the culture. You can set the format to “format:’dd/MM/yyyy hh:mm a’” in string.

Defaults to ‘dd/MM/yyyy hh:mm a’

typingUsers UserModel[]

Specifies a list of users who are currently typing in the chat.
This property is updated to indicate active participants typing responses.

Defaults to null

typingUsersTemplate string|function

Template for displaying users currently typing in the chat interface.
Accepts a string or function to customize the display format.

<template>
  <div id='container' style="height: 380px; width: 450px; margin: 0 auto;">
    <ejs-chatui id="typingUsersTemplate" :typingUsers="typingUsers" typingUsersTemplate="typingUsersTemplate" :user="currentUser" :created="created">
      <template v-slot:typingUsersTemplate="{data}">
        <div class="typing-wrapper" v-html="getTypingUsersList(data) + ` are typing...`"></div>
      </template>
      <e-messages>
        <e-message :author="currentUser" text="Hi Michale, are we on track for the deadline?" ></e-message>
        <e-message :author="michaleUser" text="Yes, the design phase is complete." ></e-message>
        <e-message :author="currentUser" text="I’ll review it and send feedback by today." ></e-message>
      </e-messages>
    </ejs-chatui>
  </div>
</template>

<script>
import { ChatUIComponent, MessagesDirective, MessageDirective } from "@syncfusion/ej2-vue-interactive-chat";

export default {
  components: {
    'ejs-chatui': ChatUIComponent,
    'e-messages': MessagesDirective,
    'e-message': MessageDirective
  },
  data() {
    return {
      currentUser: {
        id: "user1",
        user: "Albert"
      },
      michaleUser: {
        id: "user2",
        user: "Michale Suyama"
      },
      reenaUser: {
        id: "user3",
        user: "Reena"
      },
      typingUsers: []
    };
  },
  methods: {
    created(){
      this.typingUsers = [ this.michaleUser, this.reenaUser ];
    },
    getTypingUsersList(context) {
      if (!context.users || context.users.length === 0) {
        return '';
      }
      let usersList = context.users.map((user, i) => {
        let isLastUser = i === context.users.length - 1;
        return `${isLastUser && i > 0 ? 'and ' : ''}<span class="typing-user">${user.user}</span>`;
      }).join(' ');
      return usersList
    }
  }
};
</script>

Defaults to ’’

user UserModel

Represents the current user interacting with the Chat UI.
Uses the UserModel object, which contains current user information.
Messages from the current user are displayed on the right side of the Chat UI for differentiation from other participants.

Defaults to null

width string|number

Specifies the width of the Chat UI component.

Defaults to ‘100%’

Methods

addMessage

Appends a new message to the end of the Chat UI conversation area.
This method adds the specified message as the latest entry in the chat:

Parameter Type Description
message string | MessageModel The message to be added to the conversation. Accepts either a plain text string or a MessageModel object.
- If message is a string, a MessageModel will be automatically created with the current user’s details, and the message will be appended.
- If message is an instance of MessageModel, it can represent a message from either the current user or another participant and will be appended directly.

Returns void

focus

Sets focus for the input textarea in the Chat UI component.
Ensures that user input is directed to the chat input field.

Returns void

prependMessages

prepends messages to the beginning of the Chat UI conversation area.
This method adds the specified messages as the first entries in the chat:

Parameter Type Description
messages string[] | MessageModel[] The messages to be added to the conversation. Accepts an array of plain text strings or MessageModel objects.
- If an element is a string, a MessageModel will be automatically created with the current user’s details, and the message will be prepended.
- If an element is an instance of MessageModel, it can represent a message from either the current user or another participant and will be prepended directly.

Returns void

scrollToBottom

Scrolls to the last message in the conversation area of the Chat UI component.
This method allows programmatic control to ensure the chat view is scrolled to the bottom, typically used when new messages are added or to refocus on the most recent conversation.

Returns void

scrollToMessage

Scrolls to a specific message in the Chat UI component based on the provided message ID.
Locates the message with the specified ID and scrolls it to the view.

Parameter Type Description
messageId string The unique identifier of the message to navigate to the corresponding message rendered in the chat UI.

Returns void

updateMessage

Updates an existing message in the Chat UI component.
This method allows for modifying a message that has already been added to the conversation.
It requires the unique identifier of the message to be updated and the new message content as a MessageModel.

Parameter Type Description
message MessageModel The updated message content represented as a MessageModel.
msgId string The unique identifier of the message to be updated.

Returns void

Events

attachmentRemoved EmitType<RemovingEventArgs>

Fires when an attachment is removed.

attachmentUploadFailure EmitType<FailureEventArgs>

Fires when an attachment upload fails.

attachmentUploadSuccess EmitType<SuccessEventArgs>

Fires when an attachment is uploaded successfully.

beforeAttachmentUpload EmitType<BeforeUploadEventArgs>

Fires before an attachment upload begins.
Allows inspection or cancellation of the upload process.

created EmitType<Object>

Event triggers when the component is created.

mentionSelect EmitType<MentionSelectEventArgs>

Triggered when a user selects a mention from the suggestion popup in the chat UI.
This event provides details about the selected user and the current message text, allowing developers to handle mention-related logic, such as custom notifications or validation.
The cancel property in the event arguments can be set to true to prevent the default behavior of inserting the mention into the input field.

messageSend EmitType<MessageSendEventArgs>

Event triggered when a message is about to be sent in the Chat UI component.
This event allows for cancelling the send action if needed.

userTyping EmitType<TypingEventArgs>

Event triggered when the user is typing a message in the Chat UI component.
This event provides updates on the user’s typing status.

Chat Ui - ChatUIComponent

30 Sep 202624 minutes to read

Represents the Essential JS 2 Angular ChatUI Component.

<ejs-chatui></ejs-chatui>

Properties

attachmentSettings FileAttachmentSettingsModel

Specifies the configuration options for attachment handling.
Includes save URL, allowed file types, and maximum file size.

    <ejs-chatui [user]="currentUserModel" [enableAttachments]="enableAttachments" [attachmentSettings]="attachmentSettings"></ejs-chatui>
import { ChatUIModule,ChatAttachmentClickEventArgs } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel, FileAttachmentSettingsModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };

    public onAttachmentClick = (args: ChatAttachmentClickEventArgs) => {
        // Your required action here
    };

    public enableAttachments: boolean = true;
    public attachmentSettings: FileAttachmentSettingsModel = {
        saveUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Save',
        removeUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
        attachmentClick: this.onAttachmentClick
    };
}

Defaults to null

autoScrollToBottom boolean

Specifies whether the UI should automatically scroll to the bottom when a new message is added to the Chat UI component.
When set to true, the chat will automatically scroll to display the latest message, ensuring that users can see new messages without manual intervention.

Defaults to false

cssClass string

Specifies custom CSS classes for the Chat UI component.
This property enables the application of additional styling options to customize the visual appearance of the chat interface.

Defaults to ’’

emptyChatTemplate string|object

Specifies the template for rendering the empty state of the Chat UI component.
This property can accept either a string or a function to customize the appearance when there are no messages to display in the chat.

    <ejs-chatui [user]="currentUserModel">
        <ng-template #emptyChatTemplate>
          <div class="empty-chat-text"><h4><span class="e-icons e-comment-show"></span></h4><h4>No Messages Yet</   h4><p>Start a conversation to see your messages here.</p></div>
        </ng-template>
    </ejs-chatui>
import { ChatUIModule } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
}

Defaults to ’’

enableAttachments boolean

Specifies whether the attachments is enabled in the Chat UI component.

Defaults to false

enableCompactMode boolean

Enables the compact mode layout in the Chat UI component.
When enabled, all messages are aligned to the left side regardless of the sender, creating a simplified chat view.
This mode is useful for dense group conversations or compact displays (e.g., mobile,embedded).
Example: compactMode: true

Defaults to false

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRtl boolean

Enable or disable rendering component in right to left direction.

Defaults to false

footerTemplate string|object

Specifies the template for the footer area in the Chat UI component.
Defines the content or layout used to render the footer, which can be provided as a string or a function.

    <ejs-chatui #chatUIComponent [user]="currentUserModel">
        <e-messages>
            <e-message text="Hi Michale, are we on track for the deadline?" [author]="currentUserModel"></      e-message>
            <e-message text="Yes, the design phase is complete." [author]="michaleUserModel"></e-message>
            <e-message text="I’ll review it and send feedback by today." [author]="currentUserModel"></e-message>
        </e-messages>
        <ng-template #footerTemplate let-data>
          <div class="custom-footer">
            <input id="chatTextArea" class="e-input" placeholder="Type your message..."/>
            <button id="sendMessage" class="e-btn e-primary" (click)="buttonClick()"><span class="e-icons       e-send-1"></span></button>
          </div>
        </ng-template>
    </ejs-chatui>
import { ChatUIModule, ChatUIComponent } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    @ViewChild('chatUIComponent')
    public chatUIComponent!: ChatUIComponent;
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public buttonClick = () => {
        const textArea = document.getElementById('chatTextArea') as HTMLTextAreaElement;
        if (textArea && textArea.value.length > 0) {
          let value: string = textArea.value;
          textArea.value = '';
          this.chatUIComponent.addMessage(
            {
                author: this.michaleUserModel,
                text: value
            }
          );
        }
    };
}

Defaults to ’’

headerIconCss string

Specifies the CSS class for the header icon in the Chat UI component.
This property allows for custom styling of the header icon.

Defaults to ’’

headerText string

Specifies the header text to be displayed in the Chat UI component.
This property defines the text that appears in the header, which can indicate the current participant’s username or the group name, providing context for the conversation.

Defaults to ‘Chat’

headerToolbar ToolbarSettingsModel

Specifies the header toolbar settings for the Chat UI component.
Represents the configuration for toolbar items and actions within the component.

Defaults to null

height string|number

Specifies the height of the Chat UI component.

Defaults to ‘100%’

loadOnDemand boolean

Enables on-demand loading of messages, typically triggered as the user scrolls through the chat history.
When set to true, older messages will load progressively, improving performance for large message histories by avoiding initial loading of all messages.

Defaults to false

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to ’’

mentionTriggerChar string

Specifies the character that triggers the @mention suggestion popup in the chat input.
The trigger character must be a single character, such as ‘@’ or ‘#’, and is case-sensitive in the input.

Defaults to ’@’

mentionUsers UserModel[]

Specifies the list of users available for mention in the chat UI.
This property defines an array of user objects that populate the @mention suggestion popup when the mention trigger character is typed.
When typing the mentionTriggerChar (e.g., ‘@’) followed by characters filters this list to show matching users.

Defaults to null

messageTemplate string|object

Specifies the template for rendering individual messages in the Chat UI component.
This property can accept either a string or a function to customize the appearance of messages. The template context includes message and index.

    <ejs-chatui [user]="currentUserModel" [messages]="chatMessages">
        <ng-template #messageTemplate let-data>
            <div class="message-items e-card">
                <div class="message-text">{{data.message.text}}</div>
            </div>
        </ng-template>
    </ejs-chatui>
import { ChatUIModule } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel, MessageModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public chatMessages: MessageModel[] = [
        {
            author: this.currentUserModel,
            text: "Hi Michale, are we on track for the deadline?"
        },
        {
            author: this.michaleUserModel,
            text: "Yes, the design phase is complete."
        },
        {
            author: this.currentUserModel,
            text: "I’ll review it and send feedback by today."
        }
    ];
}

Defaults to ’’

messageToolbarSettings MessageToolbarSettingsModel

Specifies the settings for the message toolbar in the Chat UI component.
Configures the toolbar options associated with each message such as Reply, Forward, Copy, Pin, and Delete.
If ‘items’ is not provided, default toolbar actions [‘Copy’, ‘Reply’, ‘Pin’, ‘Delete’] will be rendered.

    <ejs-chatui #chatUIComponent [user]="currentUserModel" [messageToolbarSettings]="messageToolbarSettings">
    <e-messages>
        <e-message text="Hi Michale, are we on track for the deadline?" [author]="currentUserModel"></e-message>
        <e-message text="Yes, the design phase is complete." [author]="michaleUserModel"></e-message>
        <e-message text="I'll review it and send feedback by today." [author]="currentUserModel"></e-message>
    </e-messages>
</ejs-chatui>
import { ChatUIModule, ChatUIComponent, MessageToolbarSettingsModel, MessageToolbarItemClickedEventArgs } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewChild, ViewEncapsulation} from '@angular/core';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    @ViewChild('chatUIComponent')
    public chatUI!: ChatUIComponent;

    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public messageToolbarSettings: MessageToolbarSettingsModel = {
        items: [
            { type: 'Button', iconCss: 'e-icons e-chat-forward', tooltip: 'Forward', },
            { type: 'Button', iconCss: 'e-icons e-chat-copy', tooltip: 'Copy' },
            { type: 'Button', iconCss: 'e-icons e-chat-reply', tooltip: 'Reply' },
            { type: 'Button', iconCss: 'e-icons e-chat-pin', tooltip: 'Pin' },
            { type: 'Button', iconCss: 'e-icons e-chat-trash', tooltip: 'Delete' }
        ],
        itemClicked: (args: MessageToolbarItemClickedEventArgs) => {
            if (args.item?.prefixIcon === 'e-icons e-chat-forward' && args.message) {
                const newMessageObj = {
                    id: 'chat-message-' + (this.chatUI.messages.length + 1).toString(),
                    isForwarded: true,
                    isPinned: args.message.isPinned,
                    author: args.message.author,
                    text: args.message.text,
                    timeStamp: args.message.timeStamp,
                    timeStampFormat: args.message.timeStampFormat,
                    status: args.message.status,
                    replyTo: args.message.replyTo
                };
                this.chatUI.addMessage(newMessageObj);
            }
        }
    }
}

Defaults to []

messages MessageModel[]

Specifies a collection of messages within the Chat UI component.
Each message is represented by a MessageModel object, containing properties such as text, author, timestamp, and status.

    <ejs-chatui [user]="currentUserModel" [loadOnDemand]="true" [messages]="chatMessages"></ejs-chatui>
import { ChatUIModule } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel, MessageModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public chatMessages: MessageModel[] = [];
    public ngOnInit(): void {
        for (let i = 1; i <= 150; i++) {
            this.chatMessages.push({
                text: i % 2 === 0 
                    ? `Message ${i} from Michale` 
                    : `Message ${i} from Albert`,
                author: i % 2 === 0 ? this.michaleUserModel : this.currentUserModel
            });
        }
    }
}

Defaults to null

placeholder string

Specifies the placeholder text for the message input textarea in the Chat UI component.

Defaults to ‘Type your message…’

showFooter boolean

Specifies whether to show or hide footer in the Chat UI component.
When set to true, the footer will be visible in the Chat UI component. If false, the footer will be hidden.

Defaults to true

showHeader boolean

Specifies whether the header is displayed in the Chat UI component.
This property controls the visibility of the header, allowing users to show or hide it as needed.
When set to false, the header will be hidden from view.

Defaults to true

showTimeBreak boolean

Specifies whether time breaks are enabled for grouping chat messages by date.
When set to true, messages will be grouped based on their timestamp, creating date-wise separators within the chat.

Defaults to false

showTimeStamp boolean

Specifies whether timestamps are displayed alongside each message in the Chat UI component.
When set to true, timestamps will appear with each message, helping users track the timing of conversations.

Defaults to true

suggestionTemplate string|object

Specifies the template for rendering suggestion items in the Chat UI component.
Defines the content or layout used to render suggestion items, and can be either a string or a function.
The template context includes the index and suggestion text.

    <ejs-chatui [user]="currentUserModel" [suggestions]="suggestions">
      <e-messages>
          <e-message text="Hi Michale, are we on track for the deadline?" [author]="currentUserModel"></    e-message>
          <e-message text="Yes, the design phase is complete." [author]="michaleUserModel"></e-message>
      </e-messages>
      <ng-template #suggestionTemplate let-data>
        <div class='suggestion-item active'>
          <div class="content">{{data.suggestion}}</div>
        </div>
      </ng-template>
    </ejs-chatui>
import { ChatUIModule } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public suggestions: string[] = [ "Okay will check it", "Sounds good!"];
}

Defaults to ’’

suggestions string[]

Specifies the list of message suggestions displayed above the input textarea in the Chat UI component.
This property represents an array of suggestions that can assist the user in composing messages, providing quick replies.

    <ejs-chatui #chatui style="height: 380px; width: 450px;"
  headerText="Chat UI with Markdown"
  [user]="currentUserModel"
  [messages]="chatMessages"
  [suggestions]="suggestionsDisplay"
>
</ejs-chatui>
import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { ChatUIAllModule, ChatUIComponent, MessageModel } from '@syncfusion/ej2-angular-interactive-chat';

@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIAllModule]
})

export class AppComponent {
    @ViewChild('chatui') public chatUI!: ChatUIComponent;
  
    public currentUserModel = {
      id: 'user1',
      user: 'Albert',
    };
    public michaleUserModel = {
      id: 'user2',
      user: 'Michale Suyama',
    };
  
    // Suggestions with display text and Markdown text
    public suggestions = [
      {
        displayText: 'Share quick link',
        markdownText:
          'Check out our [project dashboard](https://www.syncfusion.com) for updates!',
      },
      {
        displayText: 'Emphasize priority',
        markdownText:
          'This is **high priority** and needs _immediate attention_.',
      },
    ];
  
    public suggestionsDisplay: string[] = this.suggestions.map(
      (s) => s.displayText
    );
    public chatMessages: MessageModel[] = [];
    public ngOnInit(): void {
        for (let i = 1; i <= 150; i++) {
            this.chatMessages.push({
                text: i % 2 === 0 
                    ? `Message ${i} from Michale` 
                    : `Message ${i} from Albert`,
                author: i % 2 === 0 ? this.michaleUserModel : this.currentUserModel
            });
        }
    }
}

Defaults to null

timeBreakTemplate string|object

Defines a custom template for rendering time breaks in the Chat UI component.
Accepts a string or function that formats the appearance of date-based separators, allowing customization of how messages are visually grouped by date.

Defaults to ’’

timeStampFormat string

Specifies the format of the value that to be displayed in component.
By default, the format will be set based on the culture. You can set the format to “format:’dd/MM/yyyy hh:mm a’” in string.

Defaults to ‘dd/MM/yyyy hh:mm a’

typingUsers UserModel[]

Specifies a list of users who are currently typing in the chat.
This property is updated to indicate active participants typing responses.

Defaults to null

typingUsersTemplate string|object

Template for displaying users currently typing in the chat interface.
Accepts a string or function to customize the display format.

    <ejs-chatui [user]="currentUserModel" [typingUsers]="typingUsers">
      <e-messages>
          <e-message text="Hi Michale, are we on track for the deadline?" [author]="currentUserModel"></    e-message>
          <e-message text="Yes, the design phase is complete." [author]="michaleUserModel"></e-message>
          <e-message text="I’ll review it and send feedback by today." [author]="currentUserModel"></e-message>
      </e-messages>
      <ng-template #typingUsersTemplate let-data>
        <div [innerHTML] = 'getUserTemplate(data)'></div>
      </ng-template>
    </ejs-chatui>
import { ChatUIModule } from '@syncfusion/ej2-angular-interactive-chat';
import { UserModel } from '@syncfusion/ej2-interactive-chat';
import { Component, ViewEncapsulation } from '@angular/core';
@Component({
  selector: "app-root",
  templateUrl: "app.component.html",
  styleUrls: ['app.component.css'],
  encapsulation: ViewEncapsulation.None,
  standalone: true,
  imports: [ChatUIModule]
})

export class AppComponent {
    public currentUserModel: UserModel = { user: 'Albert', id: 'user1' };
    public michaleUserModel: UserModel = { user: 'Michale Suyama', id: 'user2' };
    public reenaUserModel: UserModel = { user: 'Reena', id: 'user3' };
    public typingUsers: UserModel[] = [this.michaleUserModel, this.reenaUserModel];
    public getUserTemplate(context: any): string {
        if (!context.users || context.users.length === 0) {
            return '';
        }
    
        const usersList = context.users.map((user: any, i: number) => {
            const isLastUser: boolean = i === context.users.length - 1;
            return `${isLastUser && i > 0 ? 'and ' : ''}<span class="typing-user">${user.user}</span>`;
        }).join(' ');
    
        return `
            <div class="typing-wrapper">
                ${usersList} are typing...
            </div>
        `;
    }
}

Defaults to ’’

user UserModel

Represents the current user interacting with the Chat UI.
Uses the UserModel object, which contains current user information.
Messages from the current user are displayed on the right side of the Chat UI for differentiation from other participants.

Defaults to null

width string|number

Specifies the width of the Chat UI component.

Defaults to ‘100%’

Methods

addMessage

Appends a new message to the end of the Chat UI conversation area.
This method adds the specified message as the latest entry in the chat:

Parameter Type Description
message string | MessageModel The message to be added to the conversation. Accepts either a plain text string or a MessageModel object.
- If message is a string, a MessageModel will be automatically created with the current user’s details, and the message will be appended.
- If message is an instance of MessageModel, it can represent a message from either the current user or another participant and will be appended directly.

Returns void

focus

Sets focus for the input textarea in the Chat UI component.
Ensures that user input is directed to the chat input field.

Returns void

prependMessages

prepends messages to the beginning of the Chat UI conversation area.
This method adds the specified messages as the first entries in the chat:

Parameter Type Description
messages string[] | MessageModel[] The messages to be added to the conversation. Accepts an array of plain text strings or MessageModel objects.
- If an element is a string, a MessageModel will be automatically created with the current user’s details, and the message will be prepended.
- If an element is an instance of MessageModel, it can represent a message from either the current user or another participant and will be prepended directly.

Returns void

scrollToBottom

Scrolls to the last message in the conversation area of the Chat UI component.
This method allows programmatic control to ensure the chat view is scrolled to the bottom, typically used when new messages are added or to refocus on the most recent conversation.

Returns void

scrollToMessage

Scrolls to a specific message in the Chat UI component based on the provided message ID.
Locates the message with the specified ID and scrolls it to the view.

Parameter Type Description
messageId string The unique identifier of the message to navigate to the corresponding message rendered in the chat UI.

Returns void

updateMessage

Updates an existing message in the Chat UI component.
This method allows for modifying a message that has already been added to the conversation.
It requires the unique identifier of the message to be updated and the new message content as a MessageModel.

Parameter Type Description
message MessageModel The updated message content represented as a MessageModel.
msgId string The unique identifier of the message to be updated.

Returns void

Events

attachmentRemoved EmitType<RemovingEventArgs>

Fires when an attachment is removed.

attachmentUploadFailure EmitType<FailureEventArgs>

Fires when an attachment upload fails.

attachmentUploadSuccess EmitType<SuccessEventArgs>

Fires when an attachment is uploaded successfully.

beforeAttachmentUpload EmitType<BeforeUploadEventArgs>

Fires before an attachment upload begins.
Allows inspection or cancellation of the upload process.

created EmitType<Object>

Event triggers when the component is created.

mentionSelect EmitType<MentionSelectEventArgs>

Triggered when a user selects a mention from the suggestion popup in the chat UI.
This event provides details about the selected user and the current message text, allowing developers to handle mention-related logic, such as custom notifications or validation.
The cancel property in the event arguments can be set to true to prevent the default behavior of inserting the mention into the input field.

messageSend EmitType<MessageSendEventArgs>

Event triggered when a message is about to be sent in the Chat UI component.
This event allows for cancelling the send action if needed.

userTyping EmitType<TypingEventArgs>

Event triggered when the user is typing a message in the Chat UI component.
This event provides updates on the user’s typing status.

ChatUIComponent

9 Jul 202624 minutes to read

Represents the React ChatUI Component

<ChatUIComponent></ChatUIComponent>

Properties

attachmentSettings FileAttachmentSettingsModel

Specifies the configuration options for attachment handling.
Includes save URL, allowed file types, and maximum file size.

import { ChatUIComponent, UserModel, FileAttachmentSettingsModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const attachmentClick = (args) => {
        // Your required action here
    };

    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };


    const attachmentSettings: FileAttachmentSettingsModel = {
      saveUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Save',
      removeUrl: 'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
      attachmentClick: (args) => attachmentClick(args)
    };
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent user={currentUserModel} enableAttachments={true} attachmentSettings= {attachmentSettings} ></ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to null

autoScrollToBottom boolean

Specifies whether the UI should automatically scroll to the bottom when a new message is added to the Chat UI component.
When set to true, the chat will automatically scroll to display the latest message, ensuring that users can see new messages without manual intervention.

Defaults to false

cssClass string

Specifies custom CSS classes for the Chat UI component.
This property enables the application of additional styling options to customize the visual appearance of the chat interface.

Defaults to ’’

emptyChatTemplate string|function|JSX.Element

Specifies the template for rendering the empty state of the Chat UI component.
This property can accept either a string or a function to customize the appearance when there are no messages to display in the chat.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const emptyChatTemplate = () => {
        return (
          <div className="empty-chat-text">
            <h4><span className="e-icons e-comment-show"></span></h4>
            <h4>No Messages Yet</h4>
            <p>Start a conversation to see your messages here.</p>
          </div>
        );
    };

    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent user={currentUserModel} emptyChatTemplate={emptyChatTemplate}></ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to ’’

enableAttachments boolean

Specifies whether the attachments is enabled in the Chat UI component.

Defaults to false

enableCompactMode boolean

Enables the compact mode layout in the Chat UI component.
When enabled, all messages are aligned to the left side regardless of the sender, creating a simplified chat view.
This mode is useful for dense group conversations or compact displays (e.g., mobile,embedded).
Example: compactMode: true

Defaults to false

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

Defaults to false

enableRtl boolean

Enable or disable rendering component in right to left direction.

Defaults to false

footerTemplate string|function|JSX.Element

Specifies the template for the footer area in the Chat UI component.
Defines the content or layout used to render the footer, which can be provided as a string or a function.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {

    const chatInstance = React.useRef<ChatUIComponent>(null);

    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel: UserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    const sendIconClicked = () => {
        const textArea = document.getElementById('chatTextArea') as HTMLInputElement;
        if (textArea && textArea.value.length > 0) {
            let value = textArea.value;
            textArea.value = '';
            chatInstance.current.addMessage(
            {
                author: michaleUserModel,
                text: value
            });
        }
    };

    const footerTemplate = () => {
        return (
            <div className="custom-footer">
                <input id="chatTextArea" className="e-input" placeholder="Type your message..."></input>
                <button id="sendMessage" className="e-btn e-primary" onClick={sendIconClicked}>
                    <span className="e-icons e-send-1"></span>
                </button>
            </div>
        );
    };
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent id="footerTemplate" ref={chatInstance} user={currentUserModel} footerTemplate={footerTemplate}>
            <MessagesDirective>
                <MessageDirective text="Hi Michale, are we on track for the deadline?" author={currentUserModel} ></MessageDirective>
                <MessageDirective text="Yes, the design phase is complete." author={michaleUserModel} ></MessageDirective>
                <MessageDirective text="I’ll review it and send feedback by today." author={currentUserModel} ></MessageDirective>
            </MessagesDirective>
        </ChatUIComponent>
    );
}
ReactDOM.render(<App />, document.getElementById('container'));

Defaults to ’’

headerIconCss string

Specifies the CSS class for the header icon in the Chat UI component.
This property allows for custom styling of the header icon.

Defaults to ’’

headerText string

Specifies the header text to be displayed in the Chat UI component.
This property defines the text that appears in the header, which can indicate the current participant’s username or the group name, providing context for the conversation.

Defaults to ‘Chat’

headerToolbar ToolbarSettingsModel

Specifies the header toolbar settings for the Chat UI component.
Represents the configuration for toolbar items and actions within the component.

Defaults to null

height string|number

Specifies the height of the Chat UI component.

Defaults to ‘100%’

loadOnDemand boolean

Enables on-demand loading of messages, typically triggered as the user scrolls through the chat history.
When set to true, older messages will load progressively, improving performance for large message histories by avoiding initial loading of all messages.

Defaults to false

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

Defaults to ’’

mentionTriggerChar string

Specifies the character that triggers the @mention suggestion popup in the chat input.
The trigger character must be a single character, such as ‘@’ or ‘#’, and is case-sensitive in the input.

Defaults to ’@’

mentionUsers UserModel[]

Specifies the list of users available for mention in the chat UI.
This property defines an array of user objects that populate the @mention suggestion popup when the mention trigger character is typed.
When typing the mentionTriggerChar (e.g., ‘@’) followed by characters filters this list to show matching users.

Defaults to null

messageTemplate string|function|JSX.Element

Specifies the template for rendering individual messages in the Chat UI component.
This property can accept either a string or a function to customize the appearance of messages. The template context includes message and index.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel: UserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    const messageTemplate = (context) => {
        return (
          <div className="message-items e-card">
            <div className="message-text">{context.message.text}</div>
          </div>
        );
    };
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent id="messageTemplate" user={currentUserModel} messageTemplate={messageTemplate}>
            <MessagesDirective>
                <MessageDirective text="Hi Michale, are we on track for the deadline?" author={currentUserModel} ></MessageDirective>
                <MessageDirective text="Yes, the design phase is complete." author={michaleUserModel} ></MessageDirective>
                <MessageDirective text="I’ll review it and send feedback by today." author={currentUserModel} ></MessageDirective>
            </MessagesDirective>
        </ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to ’’

messageToolbarSettings MessageToolbarSettingsModel

Specifies the settings for the message toolbar in the Chat UI component.
Configures the toolbar options associated with each message such as Reply, Forward, Copy, Pin, and Delete.
If ‘items’ is not provided, default toolbar actions [‘Copy’, ‘Reply’, ‘Pin’, ‘Delete’] will be rendered.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel, MessageToolbarSettingsModel, MessageToolbarItemClickedEventArgs, MessageModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { useRef } from 'react';

function App() {
    const currentUserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    const chatUiInst = useRef(null);
    const messageToolbarSettings = {
        items: [
            { type: 'Button', iconCss: 'e-icons e-chat-forward', tooltip: 'Forward' },
            { type: 'Button', iconCss: 'e-icons e-chat-copy', tooltip: 'Copy' },
            { type: 'Button', iconCss: 'e-icons e-chat-reply', tooltip: 'Reply' },
            { type: 'Button', iconCss: 'e-icons e-chat-pin', tooltip: 'Pin' },
            { type: 'Button', iconCss: 'e-icons e-chat-trash', tooltip: 'Delete' }
        ],
        itemClicked: (args) => {
            if (args.item.prefixIcon === 'e-icons e-chat-forward') {
                const newMessageObj = {
                    id: 'chat-message-' + (chatUiInst.current.messages.length + 1).toString(),
                    isForwarded: true,
                    isPinned: args.message.isPinned,
                    author: args.message.author,
                    text: args.message.text,
                    timeStamp: args.message.timeStamp,
                    timeStampFormat: args.message.timeStampFormat,
                    status: args.message.status,
                    replyTo: args.message.replyTo
                };
                chatUiInst.addMessage(newMessageObj);
            }
        }
    }

    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent user={currentUserModel} messageToolbarSettings={messageToolbarSettings} ref={chatUiInst} >
            <MessagesDirective>
                <MessageDirective text="Hi Michale, are we on track for the deadline?" author={currentUserModel} ></MessageDirective>
                <MessageDirective text="Yes, the design phase is complete." author={michaleUserModel} ></MessageDirective>
                <MessageDirective text="I’ll review it and send feedback by today." author={currentUserModel} ></MessageDirective>
            </MessagesDirective>
        </ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to []

messages MessageModel[]

Specifies a collection of messages within the Chat UI component.
Each message is represented by a MessageModel object, containing properties such as text, author, timestamp, and status.

import { ChatUIComponent, UserModel, MessageModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel: UserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    let chatMessages: MessageModel [] = [];
    for (let i = 1; i <= 150; i++) {
        chatMessages.push({
            text: i % 2 === 0 
                ? `Message ${i} from Michale` 
                : `Message ${i} from Albert`,
            author: i % 2 === 0 ? michaleUserModel : currentUserModel
        });
    }
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent loadOnDemand={true} user={currentUserModel} messages={chatMessages}></ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to null

placeholder string

Specifies the placeholder text for the message input textarea in the Chat UI component.

Defaults to ‘Type your message…’

showFooter boolean

Specifies whether to show or hide footer in the Chat UI component.
When set to true, the footer will be visible in the Chat UI component. If false, the footer will be hidden.

Defaults to true

showHeader boolean

Specifies whether the header is displayed in the Chat UI component.
This property controls the visibility of the header, allowing users to show or hide it as needed.
When set to false, the header will be hidden from view.

Defaults to true

showTimeBreak boolean

Specifies whether time breaks are enabled for grouping chat messages by date.
When set to true, messages will be grouped based on their timestamp, creating date-wise separators within the chat.

Defaults to false

showTimeStamp boolean

Specifies whether timestamps are displayed alongside each message in the Chat UI component.
When set to true, timestamps will appear with each message, helping users track the timing of conversations.

Defaults to true

suggestionTemplate string|function|JSX.Element

Specifies the template for rendering suggestion items in the Chat UI component.
Defines the content or layout used to render suggestion items, and can be either a string or a function.
The template context includes the index and suggestion text.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel: UserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    const suggestions = [ "Okay will check it", "Sounds good!"];

    const suggestionTemplate = (context) => {
        return (
            <div className='suggestion-item active'>
                <div className="content">{context.suggestion}</div>
            </div>
        );
    };
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent id="suggestionTemplate" user={currentUserModel} suggestionTemplate={suggestionTemplate} suggestions={suggestions}>
            <MessagesDirective>
                <MessageDirective text="Hi Michale, are we on track for the deadline?" author={currentUserModel} ></MessageDirective>
                <MessageDirective text="Yes, the design phase is complete." author={michaleUserModel} ></MessageDirective>
                <MessageDirective text="I’ll review it and send feedback by today." author={currentUserModel} ></MessageDirective>
            </MessagesDirective>
        </ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to ’’

suggestions string[]

Specifies the list of message suggestions displayed above the input textarea in the Chat UI component.
This property represents an array of suggestions that can assist the user in composing messages, providing quick replies.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel, MessageModel, MessageSentEventArgs} from '@syncfusion/ej2-react-interactive-chat';
import { marked } from 'marked';
import DOMPurify from 'dompurify';
import * as React from 'react';
import * as ReactDOM from "react-dom";
function App() {
  const currentUserModel: UserModel = {
    id: 'user1',
    user: 'Albert',
  };

  const michaleUserModel: UserModel = {
    id: 'user2',
    user: 'Michale Suyama',
  };

  const suggestions= [
    {
      displayText: 'Share quick link',
      markdownText: 'Check out our [project dashboard](https://dashboard.example.com) for updates!',
    },
    {
      displayText: 'Emphasize priority',
      markdownText: 'This is **high priority** and needs _immediate attention_.',
    }
  ];

  const [messages, setMessages] = React.useState<MessageModel[]>([
    {
      text: marked.parse('Hey Michale, did you review the _new API documentation_?'),
      author: currentUserModel,
      timestamp: new Date('2024-01-15T09:30:00'),
    },
    {
      text: marked.parse(
        'Yes! The **endpoint specifications** look great. Check the [integration guide](https://api.example.com/docs) when you get a chance.'
      ),
      author: michaleUserModel,
      timestamp: new Date('2024-01-15T09:32:00'),
    }
  ]);
  const messageSend = (args: MessageSentEventArgs) => {
    args.cancel = true;
    const suggestion = suggestions.find(
      (s) => s.displayText === args.message.text
    );
    const messageText = suggestion
      ? suggestion.markdownText
      : args.message.text;
    const parsedText = DOMPurify.sanitize(marked.parse(messageText));
    const newMessage: MessageModel = {
      text: parsedText,
      author: currentUserModel,
      timestamp: new Date(),
    };
    setMessages([...messages, newMessage]);
  };

  return (
    <ChatUIComponent
      headerText={'Chat UI with Markdown'}
      user={currentUserModel}
      suggestions={suggestions.map((s) => s.displayText)}
      messageSend={messageSend}
    >
      <MessagesDirective>
        {messages.map((msg, index) => (
          <MessageDirective
            key={index}
            text={msg.text}
            author={msg.author}
            timestamp={msg.timestamp}
          />
        ))}
      </MessagesDirective>
    </ChatUIComponent>
  );
}
 
ReactDOM.render(<App />, document.getElementById('container'));

Defaults to null

timeBreakTemplate string|function|JSX.Element

Defines a custom template for rendering time breaks in the Chat UI component.
Accepts a string or function that formats the appearance of date-based separators, allowing customization of how messages are visually grouped by date.

Defaults to ’’

timeStampFormat string

Specifies the format of the value that to be displayed in component.
By default, the format will be set based on the culture. You can set the format to “format:’dd/MM/yyyy hh:mm a’” in string.

Defaults to ‘dd/MM/yyyy hh:mm a’

typingUsers UserModel[]

Specifies a list of users who are currently typing in the chat.
This property is updated to indicate active participants typing responses.

Defaults to null

typingUsersTemplate string|function|JSX.Element

Template for displaying users currently typing in the chat interface.
Accepts a string or function to customize the display format.

import { ChatUIComponent, MessagesDirective, MessageDirective, UserModel } from '@syncfusion/ej2-react-interactive-chat';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    const currentUserModel: UserModel = {
        id: "user1",
        user: "Albert"
    };

    const michaleUserModel: UserModel = {
        id: "user2",
        user: "Michale Suyama"
    };

    const reenaUserModel: UserModel = {
        id: "user3",
        user: "Reena"
    };

    const typingUsers: UserModel[] = [ michaleUserModel, reenaUserModel ];

    const typingUsersTemplate = (context) => {
      if (!context.users || context.users.length === 0) {
        return '';
      }

      let usersList = context.users.map((user, i) => {
        let isLastUser = i === context.users.length - 1;
        return `${isLastUser && i > 0 ? 'and ' : ''}<span class="typing-user">${user.user}</span>`;
      }).join(' ');
      const userTemplate = `${usersList} are typing...`;
      return (
        <div className="typing-wrapper" dangerouslySetInnerHTML= ></div>
      );
    };
    return (
        // specifies the tag for render the Chat UI component
        <ChatUIComponent user={currentUserModel} typingUsers={typingUsers} typingUsersTemplate={typingUsersTemplate}>
            <MessagesDirective>
                <MessageDirective text="Hi Michale, are we on track for the deadline?" author={currentUserModel} ></MessageDirective>
                <MessageDirective text="Yes, the design phase is complete." author={michaleUserModel} ></MessageDirective>
                <MessageDirective text="I’ll review it and send feedback by today." author={currentUserModel} ></MessageDirective>
            </MessagesDirective>
        </ChatUIComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('container'));

Defaults to ’’

user UserModel

Represents the current user interacting with the Chat UI.
Uses the UserModel object, which contains current user information.
Messages from the current user are displayed on the right side of the Chat UI for differentiation from other participants.

Defaults to null

width string|number

Specifies the width of the Chat UI component.

Defaults to ‘100%’

Methods

addMessage

Appends a new message to the end of the Chat UI conversation area.
This method adds the specified message as the latest entry in the chat:

Parameter Type Description
message string | MessageModel The message to be added to the conversation. Accepts either a plain text string or a MessageModel object.
- If message is a string, a MessageModel will be automatically created with the current user’s details, and the message will be appended.
- If message is an instance of MessageModel, it can represent a message from either the current user or another participant and will be appended directly.

Returns void

focus

Sets focus for the input textarea in the Chat UI component.
Ensures that user input is directed to the chat input field.

Returns void

prependMessages

prepends messages to the beginning of the Chat UI conversation area.
This method adds the specified messages as the first entries in the chat:

Parameter Type Description
messages string[] | MessageModel[] The messages to be added to the conversation. Accepts an array of plain text strings or MessageModel objects.
- If an element is a string, a MessageModel will be automatically created with the current user’s details, and the message will be prepended.
- If an element is an instance of MessageModel, it can represent a message from either the current user or another participant and will be prepended directly.

Returns void

scrollToBottom

Scrolls to the last message in the conversation area of the Chat UI component.
This method allows programmatic control to ensure the chat view is scrolled to the bottom, typically used when new messages are added or to refocus on the most recent conversation.

Returns void

scrollToMessage

Scrolls to a specific message in the Chat UI component based on the provided message ID.
Locates the message with the specified ID and scrolls it to the view.

Parameter Type Description
messageId string The unique identifier of the message to navigate to the corresponding message rendered in the chat UI.

Returns void

updateMessage

Updates an existing message in the Chat UI component.
This method allows for modifying a message that has already been added to the conversation.
It requires the unique identifier of the message to be updated and the new message content as a MessageModel.

Parameter Type Description
message MessageModel The updated message content represented as a MessageModel.
msgId string The unique identifier of the message to be updated.

Returns void

Events

attachmentRemoved EmitType<RemovingEventArgs>

Fires when an attachment is removed.

attachmentUploadFailure EmitType<FailureEventArgs>

Fires when an attachment upload fails.

attachmentUploadSuccess EmitType<SuccessEventArgs>

Fires when an attachment is uploaded successfully.

beforeAttachmentUpload EmitType<BeforeUploadEventArgs>

Fires before an attachment upload begins.
Allows inspection or cancellation of the upload process.

created EmitType<Object>

Event triggers when the component is created.

mentionSelect EmitType<MentionSelectEventArgs>

Triggered when a user selects a mention from the suggestion popup in the chat UI.
This event provides details about the selected user and the current message text, allowing developers to handle mention-related logic, such as custom notifications or validation.
The cancel property in the event arguments can be set to true to prevent the default behavior of inserting the mention into the input field.

messageSend EmitType<MessageSendEventArgs>

Event triggered when a message is about to be sent in the Chat UI component.
This event allows for cancelling the send action if needed.

userTyping EmitType<TypingEventArgs>

Event triggered when the user is typing a message in the Chat UI component.
This event provides updates on the user’s typing status.